% PDB structure reader

clear all
close all

PDBStruct = pdbread('C:\Users\Gebruiker\Google Drive\iGEM 2017\Modules\Cas13a\Protein struture\5wtk.pdb')
temp = struct2cell(PDBStruct.Model.Atom.').'; 
Positions = table(temp(:, 2), temp(:, 4), [PDBStruct.Model.Atom(:).resSeq].', [PDBStruct.Model.Atom(:).X].', [PDBStruct.Model.Atom(:).Y].', [PDBStruct.Model.Atom(:).Z].', 'VariableNames', {'AtomName', 'resName', 'resSeq', 'X', 'Y', 'Z'});
clear temp

CA = zeros(height(Positions),1);
%%
%Defining bins
bin_size=11.56;
x_min =14.9850000000000;
x_max = 115;
x_size=ceil(x_max/bin_size);
y_min=28.1570000000000;
y_max=121.189000000000;
y_size=ceil(y_max/bin_size);
z_min=22.6590000000000;
z_max=114.543000000000;
z_size=ceil(z_max/bin_size);

Coordinates = table2array(Positions(:,3:6));

for i=1:height(Positions)
    CA(i) = isequal(Positions.AtomName{i},'CA');
end

Num_CA=sum(CA);
Bins = zeros(height(Positions),3);

for i=1:height(Positions)
    CA(i);
    if CA(i)==1
        Bins(i,1)=ceil(Coordinates(i,2)/bin_size);
        Bins(i,2)=ceil(Coordinates(i,3)/bin_size);
        Bins(i,3)=ceil(Coordinates(i,4)/bin_size);
    end
end

Charges = zeros(x_size,y_size,z_size);
Hydrophobicity = zeros(x_size,y_size,z_size);
Units = zeros(x_size,y_size,z_size);

Bins_CA=Bins(logical(CA),:);
Residues_CA=Positions.resName(logical(CA));

% Lookup table with first column: Charge, second column: hydrophobicity]
Res_cha_hyd={'ALA' 6.0 1.0 ; 
'CYS' 5.1 0.2;
'ASP' 2.8 -3;
'GLU' 3.2 -2.6;
'PHE' 5.5 2.5;
'GLY' 6.0 0.7;
'HIS' 7.6 -1.7;
'ILE' 5.9 3.1;
'LYS' 9.7 -4.6;
'LEU' 6.0 2.2;
'MET' 5.7 1.1;
'ASN' 5.4 -2.7;
'PRO' 6.5 -0.3;
'GLN' 5.7 -2.9;
'ARG' 10.8 -7.5;
'SER' 5.7 -1.1;
'THR' 5.9 -0.8;
'VAL' 6.0 2.3;
'TRP' 6.0 1.5;
'TYR' 5.7 0.1};

Char_Res=cell2mat(Res_cha_hyd(:,2));
Hydr_Res=cell2mat(Res_cha_hyd(:,3));

for i=1:Num_CA
    for resi=1:20
        if isequal(Residues_CA(i),Res_cha_hyd(resi,1))
            Charges(Bins_CA(i,1),Bins_CA(i,2),Bins_CA(i,3))         = Charges(Bins_CA(i,1),Bins_CA(i,2),Bins_CA(i,3)) + Char_Res(resi);
            Hydrophobicity(Bins_CA(i,1),Bins_CA(i,2),Bins_CA(i,3))  = Hydrophobicity(Bins_CA(i,1),Bins_CA(i,2),Bins_CA(i,3)) + Hydr_Res(resi);
            Units(Bins_CA(i,1),Bins_CA(i,2),Bins_CA(i,3))           = 1;%Units(Bins_CA(i,1),Bins_CA(i,2),Bins_CA(i,3))+1;
        end
    end
end
